package com.cxyxiaomo.epp.shop.dao;

import com.cxyxiaomo.epp.common.pojo.Order;
import com.cxyxiaomo.epp.common.pojo.OrderDetail;
import com.cxyxiaomo.epp.common.query.OrderQuery;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

@Mapper
@Repository
public interface OrderDao {

    /**
     * 根据订单 ID 查询订单信息
     *
     * @param orderId
     * @return
     */
    Order getOrderById(Long orderId);

    /**
     * 根据订单 ID 查询订单详情
     *
     * @param orderId
     * @return
     */
    List<OrderDetail> getOrderDetailById(Long orderId);

    /**
     * 根据用户 ID 查询订单列表
     *
     * @param userId
     * @param orderStatus
     * @return
     */
    List<Order> listOrderByUserId(@Param("userId") Integer userId, @Param("orderStatus") String orderStatus);

    /**
     * 创建订单
     *
     * @param order
     * @return
     */
    int insertOrder(Order order);

    /**
     * 批量插入订单详情
     *
     * @param details
     * @return
     */
    int batchInsertOrderDetail(List<OrderDetail> details);

    /**
     * 更新订单状态
     *
     * @param orderId
     * @param orderStatus
     * @return
     */
    int updateOrderStatus(@Param("orderId") Long orderId, @Param("orderStatus") String orderStatus);

    /**
     * 更新订单发货信息
     *
     * @param orderId
     * @param expressId
     * @param comment
     * @return
     */
    int updateOrderShipInfo(@Param("orderId") Long orderId, @Param("expressId") String expressId, @Param("comment") String comment);

    // 根据订单 ID 删除订单信息及订单详情信息
    boolean deleteOrderById(Long orderId);


    public List<Order> getOrderList(OrderQuery orderQuery);
}
